function v_obj = yalmip_fsm_variables( names, varsizes, indicators, param )
           
  if ~isequal(length(names),length(varsizes),length(indicators))
       error('length of inputs must be the same!')
  end
%       names of internal variables of function yalmip_fsm    
  internal_var = {'nx','nt','nd','i','j','k','N','A','B',...
      'Ainf','Binf','Ainf_cut','Binf_cut','D','s_index','ts_index','poss_trans',...
      'in_state','t','T','d','from','to','F','model','d_used','ts'};
  
  for i=1:length(names)
        if ~isempty(strmatch(names{i},internal_var,'exact'))
             error('name of the %d-th variable conflicts with internal variable names',i)        
        end          
  end

v_obj.names = names;
v_obj.sizes =  varsizes;
v_obj.ind = indicators;
v_obj.param = param;

end

